#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFSIZE 8192
char buf[BUFSIZE];

int main(int argc, char *argv[]){
	int i;
	char *outfilename = "asmcode.s";
	FILE *fpw;
	
	if(argc < 2){
		fprintf(stderr, "usage: bero_link [-o OutputFileName] InputFileName1 ... InputFileNameN\n");
		return 1;
	}
	
	for(i = 1; i < argc; i++){
		if(!(strcmp(argv[i], "-o"))){
			if(i + 1 >= argc){
				fprintf(stderr, "output file name not exist after -o\n");
				exit(1);
			}
			
			outfilename = argv[i + 1];
		}
	}
	
	if(fpw = fopen(outfilename, "w")){
		fprintf(fpw, "jmp $PROGRAM_BEGIN$;\n");
		fprintf(fpw, "add r0, r0, r0;\n");
		
		for(i = 1; i < argc; i++){
			if(!(strcmp(argv[i], "-o")))
				i++;
			else{
				FILE *fpr;
				
				if(fpr = fopen(argv[i], "r")){
					while(fgets(buf, BUFSIZE, fpr))
						fputs(buf, fpw);
					
					if(ferror(fpr)){
						fprintf(stderr, "file read error\n");
						fclose(fpr);
						exit(1);
					}
					
					fclose(fpr);
					
					fputs("\n", fpw);
				}
				else{
					fprintf(stderr, "warning: %s not found\n", argv[i]);
				}
			}
		}
		
		fprintf(fpw, ":$-_-$;\n");
		
		fclose(fpw);
	}
	else{
		fprintf(stderr, "cannot create file %s\n", outfilename);
		exit(1);
	}
	
	return 0;
}
